%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Text = PCL_Elm_Create_Bar_Spider(Node_1, Node_2_list, Property_Set_Name)

% Счетчик db_Next_Element_Number обновляется вне данной функции после ее вызова

global fem_create_elemen_elems_created;
global db_Next_Element_Number;

Cell_array_size = 1;

if (fem_create_elemen_elems_created == 0)
    Cell_array_size = Cell_array_size + 1;
end

if (~isempty(Property_Set_Name))
    Cell_array_size = Cell_array_size + 1;
end

Text = cell(Cell_array_size,1);

counter = 0;

if (fem_create_elemen_elems_created == 0)
    
    fem_create_elemen_elems_created = 1;
    counter = counter + 1;
    Text{counter} = 'STRING fem_create_elemen_elems_created[VIRTUAL]';
    
end

Node_2_list_sorted = sortrows(Node_2_list,1);
Node_2_string = sprintf('%d', Node_2_list_sorted(1));

for i=2:size(Node_2_list,1)
    Node_2_string = [Node_2_string sprintf(' %d', Node_2_list_sorted(i))]; %#ok<AGROW>
end

counter = counter + 1;
Text{counter} = ['fem_create_elems_1( "Bar ", "Bar2", "' sprintf('%d', db_Next_Element_Number) '", "Standard", 2, "Node ' sprintf('%d', Node_1) '", "Node ' Node_2_string '", "", "", "", "", "", "", fem_create_elemen_elems_created )'];

if (~isempty(Property_Set_Name))
    
    counter = counter + 1;
    
    if (size(Node_2_list,1) == 1)
        Text{counter} = ['fem_associate_elems_to_ep( "' Property_Set_Name '", "' sprintf('%d', db_Next_Element_Number) '", 1 )'];
    else
        Text{counter} = ['fem_associate_elems_to_ep( "' Property_Set_Name '", "' sprintf('%d:%d', db_Next_Element_Number, db_Next_Element_Number + size(Node_2_list,1) - 1) '", 1 )'];
    end
    
end
